/* Autor: Burkhard Lenze */
/* Datum: 18.01.2009     */

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Locale;
import java.util.Scanner;

public class hopsi_pi 
{
 /*  globale Variablen  */
 static int[] x = new int[21];		    /* Eingabevektorfeld            */
 static int[] y = new int[21];		    /* Ausgabevektorfeld            */
 static int[] w = new int[21];		    /* Matrixfeld Gewichte 0. Ordn. */
 static int[][] ww = new int[21][21];	    /* Matrixfeld Gewichte 1. Ordn. */
 static int[][][] www = new int[21][21][21];/* Matrixfeld Gewichte 2. Ordn. */
 static int n;				    /* Anzahl Ein-/Ausgabe-Neuronen */
 static int zeile_x, spalte_x;		    /* Zeilen/Spalten Eingabebild   */
 static char com;			    /*  Menuparameter               */
	
 /* Funktionen  */
 static void lese_x()
 {
  int i, r, c, nn;
  char k;
  String dat;
  BufferedReader f = new BufferedReader(new InputStreamReader(System.in));
  System.out.println("\nWie lautet die Eingabe-Bilddatei? \n");
  try 
  {
   dat = f.readLine();
   System.out.print("\n");
   BufferedReader out = new BufferedReader(new FileReader(dat));	
   nn = Integer.parseInt(out.readLine());
   if(nn==spalte_x)
   {
	nn = Integer.parseInt(out.readLine());
	if(nn==zeile_x)
	{
	 i=1;
	 for(r=1;r<=zeile_x;r++)
	 {
	  for(c=1;c<=spalte_x+1;c++)
	  {
	   k = (char)out.read();
	   System.out.print(k);
	   if(k=='.')
	   {
		x[i]=-1;
	   }
	   if(k=='X')
	   {
		x[i]=1;
	   }
	   if(k=='\n')
	   {
		i=i-1;
	   }
	   i=i+1;
	  }
	 }
	}
	else 
	{
	 System.out.println("\nFehler! m ist " + nn + " statt " + zeile_x);
	}
   }
   else
   {
	System.out.println("\nFehler! m ist " + nn + " statt " + spalte_x);
   }
   out.close();
  } 
  catch (FileNotFoundException e) 
  {
   System.out.println("Fehler! Datei konnte nicht gefunden werden!");
  } 
  catch (IOException e) 
  {
   System.out.println("Fehler beim Lesen der Datei!");
  }
 }
	
 static int T (int A)
 {
  if(A>0)
	return(1);
  if(A<0)
	return(-1);
  else
	return(0);
 }
	
 static void lernen()
 {
  int i, j, k;
  lese_x();
  for(i=1;i<=n;i++)
  {
   w[i]=w[i]+x[i];
   for(j=1;j<i;j++)
   {
	ww[i][j]=ww[i][j]+(x[i]*x[j]);
	ww[j][i]=ww[i][j];
	for(k=1;k<j;k++)
	{
	 www[i][j][k]=www[i][j][k]+(x[i]*x[j]*x[k]);
	 www[i][k][j]=www[i][j][k];      
	 www[j][k][i]=www[i][j][k];      
	 www[j][i][k]=www[i][j][k];      
	 www[k][i][j]=www[i][j][k];      
	 www[k][j][i]=www[i][j][k];
	}
   }
  }
 }
	
 static void zeichne_x()
 {
  int i, r, c;
  i=1;
  System.out.print("\n");
  for(r=1;r<=zeile_x;r++)
  {
   for(c=1;c<=spalte_x;c++)
   {
	if(x[i]>0)
	{
	 System.out.print("X");
	}
	else
	{
	 System.out.print(".");
	}
	i=i+1;
   }
   System.out.print("\n");
  }
 }
	
 static void ausfuehren()
 {
  int i, j, k, u, C, A;
  lese_x();
  zeichne_x();
  u=-1;
  do
  {
   u=u+1;
   C=0;
   for(j=1;j<=n;j++)
   {
	A=w[j];
	for(i=1;i<=n;i++)
	{
	 A=A+(ww[i][j]*x[i]);
	 for(k=1;k<i;k++)
	 {
	  A=A+(www[k][i][j]*x[k]*x[i]);
	 }
	}
	if(A!=0)
	{
	 if(T(A)!=x[j])
	 {
	  C=1;
	 }
	 x[j]=T(A);
	}
   }
   zeichne_x();
  }
  while(C!=0);
 }
	
 static void veraendern()
 {
  int i, j, k;
  Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
  System.out.print("\n");
  System.out.print("Wieviele Zeilen im Eingabebild? ");
  zeile_x = sc.nextInt();
  System.out.print("Wieviele Spalten im Eingabebild? ");
  spalte_x = sc.nextInt();
  n=zeile_x*spalte_x;
  if(n>20)
  {
   System.out.print("\n Bild zu groß! Ggf. globale Felder vergrößern! \n ");
  }
  if(n<21)
  {
   for(i=1;i<=n;i++)
   {
	x[i]=0;
   }
   for(i=1;i<=n;i++)
   {
	w[i]=0;
	for(j=1;j<=n;j++)
	{
	 ww[j][i]=0;
	 for(k=1;k<=n;k++)
	 {
	  www[k][j][i]=0;
	 }
	}
   }
  }
 }
	
 public static void main(String[] args) 
 {
  veraendern();
  do
  {
   System.out.println("\nlernen ausfuehren veraendern beenden:\n");		
   Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
   com = sc.next().charAt(0);
   switch(com)
   {
	case 'l': lernen(); break;
	case 'a': ausfuehren(); break;
	case 'v': veraendern(); break;
	default:  break;
   }
  }
  while(com!='b');
 }
}
