/* Autor: Burkhard Lenze */
/* Datum: 18.01.2009     */

import java.util.Locale;
import java.util.Scanner;

public class hypsi_pi 
{
 /*  globale Variablen  */
 static float[][] x = new float[5][30];	     /* Eingabevektorfeld            */
 static float[][][] y = new float[5][30][30];/* Ausgabevektorfeld            */
 static float[][] rho = new float[30][30];   /* Skalierungsfaktoren          */
 static float[][] d1 = new float[30][30];    /* Matrixfeld Differenzgewichte */
 static float[][] d2 = new float[30][30];    /* Matrixfeld Differenzgewichte */
 static float[][] g = new float[30][30];     /* Matrixfeld Ausgangsgewichte  */
 static float[] x_test = new float[5];	     /* Aktueller Testeingang        */
 static float[] y_test = new float[5];	     /* Aktueller Testausgang        */
 static int Pxy;			     /* Anzahl x-y-Abtastpunkte      */
 static int n=2;		             /* Anzahl Eingabe-Neuronen      */
 static int q;				     /* Anzahl verborgene Neuronen   */
 static int m=1;			     /* Anzahl Ausgabe-Neuronen      */
 static char com;			     /* Menuparameter                */
	
 /*  Funktionen */
 static void lese_x_test()
 {
  int i;
  System.out.print("\n");
  for(i=1;i<=n;i++)
  {
   System.out.print("x[" + i + "] = ? ");
   Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
   x_test[i] = sc.nextFloat();
  }
 }
	
 static float f(float x1, float x2)
 {
  float Z;
  Z=1.0f;
  if(x1+x2>=1.5f)
	Z=0.0f;
  if((x1<=0.5)&&(x2<=0.25))
	Z=0.0f;
  if((x1<-0.0001)||(x1>1.0001))
	Z=0.0f;
  if((x2<-0.0001)||(x2>1.0001))
	Z=0.0f;
  return(Z);
 }
	
 static void lese_x_y()
 {
  int k, l;
  for(k=0;k<=Pxy;k++)
  {
   x[1][k]=(k-1.0f)/(Pxy-1.0f);
  }
  for(l=0;l<=Pxy+1;l++)
  {
   x[2][l]=(l-1.0f)/(Pxy-1.0f);
  }
  for(l=0;l<=Pxy+1;l++)
  {
   for(k=0;k<=Pxy+1;k++)
   {
	y[1][k][l]=f(((k-1.0f)/(Pxy-1.0f)),((l-1.0f)/(Pxy-1.0f)));
   }
  }
 }
	
 static float T(float A)
 {
  if(A>-0.00001)
	return(1.0f);
  else
	return(0.0f); 
 }
	
 static void lernen()
 {
  int j, kk, ll, k, l;
  float H, err;
  float[] y_ = new float[5];
  lese_x_y();
  for(l=0;l<=Pxy;l++)
  {
   for(k=0;k<=Pxy;k++)
   {
	rho[k][l]=(Pxy-1.0f)*(Pxy-1.0f);
	d1[k][l]=(k-0.5f)/(Pxy-1.0f);
	d2[k][l]=(l-0.5f)/(Pxy-1.0f);
	g[k][l]=0.5f*(y[1][k][l]-y[1][k+1][l]-y[1][k][l+1]+y[1][k+1][l+1]);
   }
  }
  err=0.0f;
  for(ll=1;ll<=Pxy;ll++)
  {
   for(kk=1;kk<=Pxy;kk++)
   {
	for(j=1;j<=m;j++)
	{
	 y_[j]=0.0f;
	 for(l=0;l<=Pxy;l++)
	 {
	  for(k=0;k<=Pxy;k++)
	  {
	   H=rho[k][l]*(x[1][kk]-d1[k][l]);
	   H=H*(x[2][ll]-d2[k][l]);
	   y_[j]=y_[j]+g[k][l]*T(H);
	  }
	 }
	 err=err+(y[j][kk][ll]-y_[j])*(y[j][kk][ll]-y_[j]);
	}
   }
  }
  System.out.print("\nDer Fehler lautet wie erwartet: " + err + ".");
  System.out.print("\n");
 }
	
 static void ausfuehren()
 {
  int j, k, l;
  float H;
  lese_x_test();
  for(j=1;j<=m;j++)
  {
   y_test[j]=0.0f;
   for(l=0;l<=Pxy;l++)
   {
    for(k=0;k<=Pxy;k++)
	{
	 H=rho[k][l]*(x_test[1]-d1[k][l]);
	 H=H*(x_test[2]-d2[k][l]);
	 y_test[j]=y_test[j]+g[k][l]*T(H);
	}
   }
  }
  System.out.print("\n");
  for(j=1;j<=m;j++)
  {
   System.out.print("y[" + j + "] = " + y_test[j]);
  }
 }
	
 static void veraendern()
 {
  Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
  System.out.print("\n");
  System.out.print("Anzahl Pxy der x-y-Abtastpunkte? ");
  Pxy = sc.nextInt();
  q=(Pxy+1)*(Pxy+1);
  System.out.print("\nEs ist also n = " + n + ".");
  System.out.print("\nEs ist also q = " + q + ".");
  System.out.print("\nEs ist also m = " + m + ".");
 }
	
 public static void main(String[] args) 
 {
  veraendern();
  do
  {
   System.out.println("\n\nlernen ausfuehren veraendern beenden:\n");	
   Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
   com = sc.next().charAt(0);
   switch(com)
   {
	case 'l': lernen(); break;
	case 'a': ausfuehren(); break;
	case 'v': veraendern(); break;
	default:  break;
   }
  }
  while(com!='b');
 }
}
