/* Autor: Burkhard Lenze */
/* Datum: 18.01.2009     */

import java.util.Locale;
import java.util.Scanner;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

public class percept2 
{
 /*  globale Variablen  */	
 static float[][] x = new float[10][100];/*  Eingabevektorfeld               */
 static float[][] y = new float[10][100];/*  Ausgabevektorfeld               */
 static float[] theta = new float[10];   /*  Schwellwertvektorfeld           */
 static float[][] w = new float[10][10]; /*  Matrixfeld der Gewichte         */
 static float[] x_test = new float[10];  /*  Aktueller Testeingang           */
 static float[] y_test = new float[10];	 /*  Aktueller Testausgang           */
 static int n;				 /*  Anzahl der Eingabe-Neuronen     */
 static int m;				 /*  Anzahl der Ausgabe-Neuronen     */
 static int t;				 /*  Anzahl der Assoziationen        */
 static int s;				 /*  Anzahl der Trainingszyklen      */
 static int s_max;			 /*  Maximalzahl der Trainingszyklen */
 static char com;			 /*  Menuparameter                   */
	
 /* Funktionen  */
 static void lese_x_test()
 {
  int i;
  System.out.print("\n");
  for(i=1;i<=n;i++)
  {
   System.out.print("x[" + i + "] = ? ");
   Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
   x_test[i] = sc.nextFloat();
  }
 }
	
 static void lese_x()
 {
  int i;
  System.out.print("\n");
  for(i=1;i<=n;i++)
  {
   System.out.print("x[" + i + "][" + s +  "] = ? ");
   Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
   x[i][s] = sc.nextFloat();
  }
 }
	
 static void lese_y()
 {
  int j;
  System.out.print("\n");
  for(j=1;j<=m;j++)
  {
   System.out.print("y[" + j + "][" + s + "] = ? ");
   Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
   y[j][s] = sc.nextFloat();
  }
 }
	
 static float T(float A)
 {
  if (A>-0.00001)
	return (1.0f);
  else
	return (0.0f);
 }
	
 static void lernen()
 {
  int i, j, st, err, z;
  float A;
  float[] y_ = new float[10];
  for(s=1;s<=t;s++)
  {
   lese_x();
   lese_y();
  }
  s=0;
  do
  {
   err=0;
   s=s+1;
   for(st=1;st<=t;st++)
   {
	for(j=1;j<=m;j++)
	{
	 A=0.0f;
	 for(i=0;i<=n;i++)
	 {
	  A=A+(w[i][j]*x[i][st]);
	 }
	 y_[j]=T(A-theta[j]);
	 for(i=0;i<=n;i++)
	 {
	  w[i][j]=w[i][j]+((y[j][st]-y_[j])*x[i][st]);
	 }
	 theta[j]=theta[j]-(y[j][st]-y_[j]);
	}
   }
   for(st=1;st<=t;st++)
   {
	for(j=1;j<=m;j++)
	{
	 A=0.0f;
	 for(i=1;i<=n;i++)
	 {
	  A=A+(w[i][j]*x[i][st]);
	 }
	 y_[j]=T(A-theta[j]);
	if(Math.abs(y[j][st]-y_[j])>0.000001)
		err=err+1;
	}
   }
   z=1;
   if((s_max/100)>=1)
	   z=s_max/100;
   if(s%z==0)
   {
	System.out.print("\nEs wurden " + s + " Lernzyklen durchlaufen! ");
	System.out.print("\nDer summierte absolute Fehler lautet: " + err);
   }
   if(err==0)
   {
	System.out.print("\n\nEs wurden " + s + " Lernzyklen durchlaufen! ");
	System.out.print("\nDer summierte absolute Fehler lautet: " + err);
	System.out.print("\n\nKonvergenz des Lernalgorithmus !!!\n");
   }
   if(s==s_max)
   {
	System.out.print("\n\nEs wurden " + s +  " Lernzyklen durchlaufen! ");
	System.out.print("\nDer summierte absolute Fehler lautet noch: " + err);
	System.out.print("\n\nAbbruch des Lernalgorithmus !!!\n");
   }
  }
  while((err!=0)&&(s!=s_max));
 }
	
 static void ausfuehren()
 {
  int i, j;
  float A;
  lese_x_test();
  for(j=1;j<=m;j++)
  {
   A=0.0f;
   for(i=1;i<=n;i++)
   {
	A=A+(w[i][j]*x_test[i]);
   }
   y_test[j]=T(A-theta[j]);
  }
  System.out.print("\n");
  for(j=1;j<=m;j++)
  {
   System.out.print("y[" + j + "] = " + y_test[j] + "\n");
  }
 }
	
 static void veraendern()
 {
  int i, j;
  s=0;
  Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
  System.out.print("\n");
  System.out.print("Anzahl n der Neuronen in der Eingabeschicht? ");
  n = sc.nextInt();
  System.out.print("Anzahl m der Neuronen in der Ausgabeschicht? ");
  m = sc.nextInt();
  System.out.print("Anzahl t der zu lernenden Assoziationen? ");
  t = sc.nextInt();
  System.out.print("Anzahl s_max der maximal zu durchlaufenden Lernzyklen? ");
  s_max = sc.nextInt();
  for(i=1;i<=n;i++){x[i][0] = 0.0f;}
  for(j=1;j<=m;j++){y[j][0] = 0.0f;}
  for(j=1;j<=m;j++)
  {
   for(i=1;i<=n;i++){w[i][j] = 0.0f;}
   theta[j]=0.0f;
  }
 }
	
 static void zeigen()
 {
  int i, j;
  System.out.print("\nDie Gewichte w[i][j] nach " + s + " Lernzyklen:\n");
  for(j=1;j<=m;j++)
  {
   for(i=1;i<=n;i++)
   {
	System.out.print("w[" + i + "][" + j + "] = " + w[i][j] + "   ");
   }
   System.out.print("\n");
  }
  System.out.print("\nDie Schwellwerte theta[j] nach " + s + " Lernzyklen:\n");
  for(j=1;j<=m;j++)
  {
   System.out.print("theta[" + j + "] = " + theta[j] + "\n");
  }
  System.out.print("\n");
 }
	
 static void speichern()
 {
  int i, j;
  String dat;
  BufferedReader f = new BufferedReader(new InputStreamReader(System.in));
  System.out.println("\nWie lautet die Datei für Gewichte und Schwellwerte? ");
  try 
  {
   dat = f.readLine();
   BufferedWriter in = new BufferedWriter(new FileWriter(dat));
   in.write(n + "\n");
   in.write(m + "\n");
   for(j=1;j<=m;j++)
   {
	for(i=1;i<=n;i++)
	{
	 in.write(w[i][j] + "\n");
	}
   }
   for(j=1;j<=m;j++)
   {
	in.write(theta[j] + "\n");
   }
   in.close();
  } 
  catch (IOException e) 
  {
   System.out.println("Fehler beim Schreiben der Datei!");
  }
 }
	
 static void einlesen()
 {
  int i, j, r;
  String dat;
  BufferedReader f = new BufferedReader(new InputStreamReader(System.in));
  System.out.println("\nWie lautet die Datei für Gewichte und Schwellwerte? ");
  try 
  {
   dat = f.readLine();
   BufferedReader out = new BufferedReader(new FileReader(dat));
   r = Integer.parseInt(out.readLine());
   if (r==n)
   {
	r = Integer.parseInt(out.readLine());
	if(r==m)
    {
	 for(j=1;j<=m;j++)
	 {
	  for(i=1;i<=n;i++)
	  {
	   w[i][j] = Float.parseFloat(out.readLine());
	  }
	 }
	 for(j=1;j<=m;j++)
	 {
	  theta[j] = Float.parseFloat(out.readLine());
	 }
	}
	else
	{
	 System.out.println("\nFehler! m ist in Datei " + r + " statt " + m);
	}
   }
   else
   {
	System.out.println("\nFehler! n ist in Datei " + r + " statt " + n);
   }
   out.close();
  } 
  catch (FileNotFoundException e) 
  {
   System.out.println("Fehler! Datei konnte nicht gefunden werden!");
  } 
  catch (IOException e) 
  {
   System.out.println("Fehler beim Lesen der Datei!");
  }
 }
	
 public static void main(String[] args) 
 {
  veraendern();
  do
  {
   System.out.println("\nlernen ausfuehren zeigen veraendern speichern einlesen beenden:\n");		
   Scanner sc = new Scanner(System.in).useLocale(Locale.ENGLISH);
   com = sc.next().charAt(0);
   switch(com)
   {
	case 'l': lernen(); break;
	case 'a': ausfuehren(); break;
	case 'z': zeigen(); break;
	case 'v': veraendern(); break;
	case 's': speichern(); break;
	case 'e': einlesen(); break;
	 default:  break;
   }
  }
  while(com!='b');
 }
}
